#!/bin/bash
#
#####################################
# DVSwitch Intallation
# May. 11, 2020
# HL5KY
#####################################

DVS="/usr/local/dvs/"
AB="/opt/Analog_Bridge/"
MB="/opt/MMDVM_Bridge/"


#---------Reinstallation --------------------------------------------------------
if [ -e ${AB}Analog_Bridge.ini ]; then
	if (whiptail --title " DVSwitch Already Installed " --yesno "\
           DVSwitch is already installed\n
        Do you want to reinstall DVSwitch ?\
" 10 55); then :
        else ${DVS}install_config.sh; exit 0
	fi

	if (whiptail --title " DVSwitch Reinstallation " --yesno "\
      Reinstallation will take less than 5 mins\n
                 <Yes> to continue\
" 10 55); then :
        else ${DVS}install_config.sh; exit 0
	fi
fi


#---------First time installation ------------------------------------------------
if [ ! -e ${AB}Analog_Bridge.ini ]; then
	if (whiptail --title " DVSwitch Installation " --yesno "\
        Installation will take 30~60 mins\n
                 <Yes> to continue\
" 10 55); then :
	else ${DVS}install_config.sh; exit 0
	fi

	if (whiptail --title " DVSwitch Installation " --yesno "\
         Again, this will take 30~60 mins\n
                 <Yes> to continue\
" 10 55); then :
        else ${DVS}install_config.sh; exit 0
	fi
fi
#----------------------------------------------------------------------------------


# On reinstallation of DVSwitch, if there is dvsm.basic which means Advanced macro is being used, move files into the ab directory.
# After installing DVSwitch, will retrive them.
if [ -d ${AB} ] && [ -e ${AB}dvsm.basic ]; then
        sudo \mv -f ${AB}A*.txt ${DVS}ab/
        sudo \mv -f ${AB}dvsm.macro ${DVS}ab/
        sudo \mv -f ${AB}dvsm.sh ${DVS}ab/
fi

echo
echo
echo "########################################"
echo "### Start DVSwitch Intallation ###"
echo "########################################"
echo
start_time=`date +%s`
start_time_string=`date`

echo
echo
echo "==========================="
echo "apt-get update"
echo "==========================="
echo
sudo apt-get update

echo
echo
echo "==========================="
echo "apt-get upgrade -y"
echo "==========================="
echo
sudo apt-get upgrade -y

echo "--------------------------"
echo "cd /tmp"
echo "--------------------------"
cd /tmp

echo
echo
echo "=============================================================================="
echo "wget https://github.com/DVSwitch/DVSwitch-System-Builder/archive/master.zip"
echo "=============================================================================="
echo
sudo wget https://github.com/DVSwitch/DVSwitch-System-Builder/archive/master.zip

echo "--------------------------"
echo "cd /srv"
echo "--------------------------"
cd /srv

echo "--------------------------"
echo "sudo unzip /tmp/master.zip"
echo "--------------------------"
sudo unzip /tmp/master.zip

echo "---------------------------------------------------------------"
echo "sudo mv DVSwitch-System-Builder-master DVSwitch-System-Builder"
echo "---------------------------------------------------------------"
sudo mv DVSwitch-System-Builder-master DVSwitch-System-Builder

echo "--------------------------"
echo "cd DVSwitch-System-Builder"
echo "--------------------------"
cd DVSwitch-System-Builder

echo
echo
echo "=================================="
echo "***  Building DVSwitch-System  ***"
echo "=================================="
echo
echo "sudo ./DVSwitch-System-Builder.sh"
echo "----------------------------------"
sudo ./DVSwitch-System-Builder.sh

echo
echo
echo "========================================"
echo "     Building DVSwitch-System     "
echo "             Finished      "
echo "========================================"
echo

# After reinstallation of DVWitch, if Advanced macro was being used, retrive files from ${DVS}ab/ to ${AB} directory.
if [ -e ${AB}dvsm.basic ]; then
        sudo cp ${DVS}ab/*.* ${AB}
fi

echo
echo
echo "========================================"
echo "          Update Binary Files      "
echo "========================================"
echo
echo

sudo systemctl stop mmdvm_bridge
sudo systemctl stop analog_bridge

echo "----------------------------------------------"
echo "sudo /usr/local/sbin/./update-from-github.sh"
echo "----------------------------------------------"
sudo /usr/local/sbin/./update-from-github.sh

sudo service quantar_bridge restart
sudo service mmdvm_bridge restart
sudo service analog_bridge restart


end_time=`date +%s`
end_time_string=`date`
elapsed_time=`echo "$end_time - $start_time" | bc`

mtime=`echo "($elapsed_time/60)" | bc`
stime=`echo "$elapsed_time - (($elapsed_time/60) * 60)" | bc`

echo
echo
echo "############################################################"
echo
echo "            DVSwitch Installation Finished"
echo
echo "            Start time : $start_time_string"
echo "            End time   : $end_time_string"
echo "            Total time : ${mtime} M ${stime} S"
echo "------------------------------------------------------------"
echo
echo "                <Enter> to Continue"
echo
echo "############################################################"
echo
echo

read x

${DVS}install_config.sh; exit 0

exit 0
