#!/bin/bash

DVS="/usr/local/dvs/"
AB="/opt/Analog_Bridge/"
MB="/opt/MMDVM_Bridge/"


if (whiptail --title " DVSwitch Reinstallation " --yesno\
       ".                                                      \
        .      Reinstallation will take less than 5 mins       \
        .                                                      \
        .             <Yes> to continue                    \
        .                                                      \
        .  when asked replacing files, type in \"A\" for All   \
                                                               " 12 60); then

    	echo "=== Confirmed ==="
	else
	${DVS}dvs; exit 0
fi

# On reinstallation of DVSwitch, copy dvsm.macro into the ab directory. After installing DVSwitch, retrive it.
if [ -e ${AB}dvsm.macro ]; then
	sudo cp -f ${AB}dvsm.macro ${DVS}ab/
fi

start_time=`date +%s`
start_time_string=`date`

sudo apt-get update

sudo apt-get upgrade -y
cd /tmp

sudo wget https://github.com/DVSwitch/DVSwitch-System-Builder/archive/master.zip

cd /srv
sudo unzip /tmp/master.zip
sudo mv DVSwitch-System-Builder-master DVSwitch-System-Builder
cd DVSwitch-System-Builder

sudo ./DVSwitch-System-Builder.sh

# After reinstallation of DVWitch, retrive dvsm.macro to the original directory.
if [ -e ${DVS}ab/dvsm.macro ]; then
	sudo mv -f ${DVS}ab/dvsm.macro ${AB}
fi

sudo systemctl stop mmdvm_bridge
sudo systemctl stop analog_bridge

sudo /usr/local/sbin/./update-from-github.sh

sudo service quantar_bridge restart
sudo service mmdvm_bridge restart
sudo service analog_bridge restart

${DVS}edit_auto.sh r

${DVS}ambe.sh r

end_time=`date +%s`
end_time_string=`date`
elapsed_time=`echo "$end_time - $start_time" | bc`

mtime=`echo "($elapsed_time/60)" | bc`
stime=`echo "$elapsed_time - (($elapsed_time/60) * 60)" | bc`

echo
echo
echo "############################################################"
echo
echo "            Reinstallation Finished"
echo
echo "            Start time : $start_time_string"
echo "            End time   : $end_time_string"
echo "            Total time : ${mtime} M ${stime} S"
echo "------------------------------------------------------------"
echo
echo "                <Enter> to REBOOT"
echo
echo "############################################################"
echo
echo

read x

sudo reboot

exit 0
